'Requires CoreScript to be included
  
Class BevelBtnMod
	Inherits BevelButton
	sub Constructor()
		super.Constructor()
		me.ButtonType = 1
		me.visible = true
	end sub
	Event Action(byref shift as Boolean, byref option As Boolean, byref command as Boolean, byref control as Boolean, byref keyDown as Boolean)
	
	sub handleAction() handles Action
		dim shift as Boolean = false
		dim option as Boolean = false
		dim command as boolean = false
		dim control as boolean = false
		dim keydown as boolean = KeyEmitter.isKeydown
		  
		'get the result from an instance (all arguments are by ref)
		Action(shift, option, command, control, keydown)
		  
		'first the keydown, otherwise the rest of the setters are doing wrong things
		KeyEmitter.isKeydown = keydown
		KeyEmitter.Shift = shift
		KeyEmitter.Option = option
		KeyEmitter.Command = command
		KeyEmitter.Control = control
	end sub
end Class

Class BevelBtnEx
	Inherits BevelButton
	dim charcode As Variant
	sub handleAction() handles Action
		KeyEmitter.EmitKeyStroke(me)
		print me.caption
	end sub

	sub Constructor()
		super.Constructor()
		me.charCode =""
		me.ButtonType = 0
		me.AddActionEvent()
		me.visible = true
	end sub
end Class

Class KeyEmitter
	Private Shared mCommand As Boolean
	Private Shared mCommandState As Boolean
	Private Shared mControl As Boolean
	Private Shared mControlState As Boolean
	Private Shared mOption As Boolean
	Private Shared mOptionState As Boolean
	Private Shared mShift As Boolean
	Private Shared mShiftState As Boolean

	Shared isKeydown As boolean

	Shared Sub EmitKeyStroke(b as BevelBtnEx)
		if b.charCode.type = 2 then
			EmitKeyInteger b.charCode, true
			EmitKeyInteger b.charCode, false
		elseif b.charCode.type = 8 then
			EmitKeyString b.charCode, true
			EmitKeyString b.charCode, false
		end if
	End Sub

	Shared function Command() As Boolean
		return mCommandState
	End function
	Shared sub Command(Assigns value As Boolean)
		mCommand = value
		if mCommandState = not isKeydown and mCommand then
			mCommandState = isKeydown
			EmitModifier(false, false, false, true, isKeydown)
		end if
	End sub
	
	Shared function Control() As Boolean
		return mControlState
	End function
	Shared sub Control(Assigns value As Boolean)
		mControl = value
		if mControlState = not isKeydown and mControl then
			mControlState = isKeydown
			EmitModifier(false, false, true, false, isKeydown)
		end if
	End Sub

	Shared function Option() As Boolean
		return mOptionState
	End function
	Shared sub Option(Assigns value As Boolean) 
		mOption = value
		if mOptionState = not isKeydown and mOption then
			mOptionState = isKeydown
			EmitModifier(false, true, false, false, isKeydown)
		end if
	End sub

	Shared function Shift() As Boolean
		return mShiftState
	End function
	Shared sub Shift(Assigns value As Boolean)
		mShift = value
		if mShiftState = not isKeyDown and mShift then
			mShiftState = isKeyDown
			EmitModifier(true, false, false, false, isKeyDown)
		end if
	End Sub


end Class

dim win as window

dim bevel1 As BevelBtnEx
dim bevel2 As BevelBtnEx
dim bevel3 As BevelBtnEx
dim bevel_unquote As BevelBtnEx
dim bevel_esc As BevelBtnEx
dim bevel4 As BevelBtnEx
dim bevel5 As BevelBtnEx
dim bevel6 As BevelBtnEx
dim bevel7 As BevelBtnEx
dim bevel8 As BevelBtnEx
dim bevel9 As BevelBtnEx
dim bevel0 As BevelBtnEx
dim bevel_minus As BevelBtnEx
dim bevel_equal As BevelBtnEx
dim bevel_delete As BevelBtnEx
dim bevelQ As BevelBtnEx
dim bevelW As BevelBtnEx
dim bevelE As BevelBtnEx
dim bevelR As BevelBtnEx
dim bevelT As BevelBtnEx
dim bevelY As BevelBtnEx
dim bevelU As BevelBtnEx
dim bevelI As BevelBtnEx
dim bevelO As BevelBtnEx
dim bevelP As BevelBtnEx
dim bevel_brkt_open As BevelBtnEx
dim bevel_brkt_close As BevelBtnEx
dim bevel_backslash As BevelBtnEx
dim bevel_tab As BevelBtnEx
dim bevelA As BevelBtnEx
dim bevelS As BevelBtnEx
dim bevelD As BevelBtnEx
dim bevelF As BevelBtnEx
dim bevelG As BevelBtnEx
dim bevelH As BevelBtnEx
dim bevel_caps_lock As BevelBtnMod
dim bevelJ As BevelBtnEx
dim bevelK As BevelBtnEx
dim bevelL As BevelBtnEx
dim bevel_colon As BevelBtnEx
dim bevel_quote As BevelBtnEx
dim bevel_return As BevelBtnEx
dim bevel_F1 As BevelBtnEx
dim bevel_F2 As BevelBtnEx
dim bevel_F3 As BevelBtnEx
dim bevel_F4 As BevelBtnEx
dim bevel_F5 As BevelBtnEx
dim bevel_F6 As BevelBtnEx
dim bevel_F7 As BevelBtnEx
dim bevel_F8 As BevelBtnEx
dim bevel_F9 As BevelBtnEx
dim bevel_F10 As BevelBtnEx
dim bevel_F11 As BevelBtnEx
dim bevel_F12 As BevelBtnEx
dim bevel_F13 As BevelBtnEx
dim bevelZ As BevelBtnEx
dim bevelX As BevelBtnEx
dim bevelC As BevelBtnEx
dim bevelV As BevelBtnEx
dim bevelB As BevelBtnEx
dim bevelN As BevelBtnEx
dim bevelM As BevelBtnEx
dim bevel_comma As BevelBtnEx
dim bevel_dot As BevelBtnEx
dim bevel_fwdslash As BevelBtnEx
dim bevel_shift_left As BevelBtnMod
dim bevel_shift_right As BevelBtnMod
dim bevel_option As BevelBtnMod
dim bevel_control As BevelBtnMod
dim bevel_fn As BevelBtnMod
dim bevel_cmd_l As BevelBtnMod
dim bevel_space As BevelBtnEx
dim bevel_cmd_r As BevelBtnMod
dim bevel_option2 As BevelBtnMod
dim bevel_arrow_up As BevelBtnEx
dim bevel_arrow_down As BevelBtnEx
dim bevel_arrow_left As BevelBtnEx
dim bevel_arrow_right As BevelBtnEx

sub InstallPlugin()

	win = ActionWindow()
	win.hide()
	win.height = 306
	win.width = 692
	

	bevel1 = new BevelBtnEx
	bevel1.charcode = "1"
	bevel1.caption = "1"
	bevel1.ButtonType = 0
	bevel1.Value = False
	bevel1.left = 65
	bevel1.top = 117
	bevel1.width = 44
	bevel1.height = 33
	
	bevel1.AddToWindow()

	bevel2 = new BevelBtnEx
	bevel2.charcode = "2"
	bevel2.caption = "2"
	bevel2.ButtonType = 0
	bevel2.Value = False
	bevel2.left = 110
	bevel2.top = 117
	bevel2.width = 44
	bevel2.height = 33

	bevel2.AddToWindow()

	bevel3 = new BevelBtnEx
	bevel3.charcode = "3"
	bevel3.caption = "3"
	bevel3.ButtonType = 0
	bevel3.Value = False
	bevel3.left = 155
	bevel3.top = 117
	bevel3.width = 44
	bevel3.height = 33

	bevel3.AddToWindow()

	bevel_unquote = new BevelBtnEx
	bevel_unquote.charcode = "`"
	bevel_unquote.caption = "`"
	bevel_unquote.ButtonType = 0
	bevel_unquote.Value = False
	bevel_unquote.left = 20
	bevel_unquote.top = 117
	bevel_unquote.width = 44
	bevel_unquote.height = 33

	bevel_unquote.AddToWindow()

	bevel_esc = new BevelBtnEx
	bevel_esc.charcode = 27
	bevel_esc.caption = "esc"
	bevel_esc.ButtonType = 0
	bevel_esc.Value = False
	bevel_esc.left = 20
	bevel_esc.top = 94
	bevel_esc.width = 46
	bevel_esc.height = 22

	bevel_esc.AddToWindow()

	bevel4 = new BevelBtnEx
	bevel4.charcode = "4"
	bevel4.caption = "4"
	bevel4.ButtonType = 0
	bevel4.Value = False
	bevel4.left = 200
	bevel4.top = 117
	bevel4.width = 44
	bevel4.height = 33

	bevel4.AddToWindow()

	bevel5 = new BevelBtnEx
	bevel5.charcode = "5"
	bevel5.caption = "5"
	bevel5.ButtonType = 0
	bevel5.Value = False
	bevel5.left = 245
	bevel5.top = 117
	bevel5.width = 44
	bevel5.height = 33

	bevel5.AddToWindow()

	bevel6 = new BevelBtnEx
	bevel6.charcode = "6"
	bevel6.caption = "6"
	bevel6.ButtonType = 0
	bevel6.Value = False
	bevel6.left = 290
	bevel6.top = 117
	bevel6.width = 44
	bevel6.height = 33

	bevel6.AddToWindow()

	bevel7 = new BevelBtnEx
	bevel7.charcode = "7"
	bevel7.caption = "7"
	bevel7.ButtonType = 0
	bevel7.Value = False
	bevel7.left = 335
	bevel7.top = 117
	bevel7.width = 44
	bevel7.height = 33

	bevel7.AddToWindow()

	bevel8 = new BevelBtnEx
	bevel8.charcode = "8"
	bevel8.caption = "8"
	bevel8.ButtonType = 0
	bevel8.Value = False
	bevel8.left = 380
	bevel8.top = 117
	bevel8.width = 44
	bevel8.height = 33

	bevel8.AddToWindow()

	bevel9 = new BevelBtnEx
	bevel9.charcode = "9"
	bevel9.caption = "9"
	bevel9.ButtonType = 0
	bevel9.Value = False
	bevel9.left = 425
	bevel9.top = 117
	bevel9.width = 44
	bevel9.height = 33

	bevel9.AddToWindow()

	bevel0 = new BevelBtnEx
	bevel0.charcode = "0"
	bevel0.caption = "0"
	bevel0.ButtonType = 0
	bevel0.Value = False
	bevel0.left = 470
	bevel0.top = 117
	bevel0.width = 44
	bevel0.height = 33

	bevel0.AddToWindow()

	bevel_minus = new BevelBtnEx
	bevel_minus.charcode = "-"
	bevel_minus.caption = "-"
	bevel_minus.ButtonType = 0
	bevel_minus.Value = False
	bevel_minus.left = 515
	bevel_minus.top = 117
	bevel_minus.width = 44
	bevel_minus.height = 33

	bevel_minus.AddToWindow()

	bevel_equal = new BevelBtnEx
	bevel_equal.charcode = "="
	bevel_equal.caption = "="
	bevel_equal.ButtonType = 0
	bevel_equal.Value = False
	bevel_equal.left = 560
	bevel_equal.top = 117
	bevel_equal.width = 44
	bevel_equal.height = 33

	bevel_equal.AddToWindow()

	bevel_delete = new BevelBtnEx
	bevel_delete.charcode = 8
	bevel_delete.caption = "delete"
	bevel_delete.ButtonType = 0
	bevel_delete.Value = False
	bevel_delete.left = 605
	bevel_delete.top = 117
	bevel_delete.width = 67
	bevel_delete.height = 33

	bevel_delete.AddToWindow()

	bevelQ = new BevelBtnEx
	bevelQ.charcode = "Q"
	bevelQ.caption = "q"
	bevelQ.ButtonType = 0
	bevelQ.Value = False
	bevelQ.left = 88
	bevelQ.top = 151
	bevelQ.width = 44
	bevelQ.height = 33

	bevelQ.AddToWindow()

	bevelW = new BevelBtnEx
	bevelW.charcode = "W"
	bevelW.caption = "w"
	bevelW.ButtonType = 0
	bevelW.Value = False
	bevelW.left = 133
	bevelW.top = 151
	bevelW.width = 44
	bevelW.height = 33

	bevelW.AddToWindow()

	bevelE = new BevelBtnEx
	bevelE.charcode = "E"
	bevelE.caption = "e"
	bevelE.ButtonType = 0
	bevelE.Value = False
	bevelE.left = 178
	bevelE.top = 151
	bevelE.width = 44
	bevelE.height = 33

	bevelE.AddToWindow()

	bevelR = new BevelBtnEx
	bevelR.charcode = "R"
	bevelR.caption = "r"
	bevelR.ButtonType = 0
	bevelR.Value = False
	bevelR.left = 223
	bevelR.top = 151
	bevelR.width = 44
	bevelR.height = 33

	bevelR.AddToWindow()

	bevelT = new BevelBtnEx
	bevelT.charcode = "T"
	bevelT.caption = "t"
	bevelT.ButtonType = 0
	bevelT.Value = False
	bevelT.left = 268
	bevelT.top = 151
	bevelT.width = 44
	bevelT.height = 33

	bevelT.AddToWindow()

	bevelY = new BevelBtnEx
	bevelY.charcode = "Y"
	bevelY.caption = "y"
	bevelY.ButtonType = 0
	bevelY.Value = False
	bevelY.left = 313
	bevelY.top = 151
	bevelY.width = 44
	bevelY.height = 33

	bevelY.AddToWindow()

	bevelU = new BevelBtnEx
	bevelU.charcode = "U"
	bevelU.caption = "u"
	bevelU.ButtonType = 0
	bevelU.Value = False
	bevelU.left = 358
	bevelU.top = 151
	bevelU.width = 44
	bevelU.height = 33

	bevelU.AddToWindow()

	bevelI = new BevelBtnEx
	bevelI.charcode = "I"
	bevelI.caption = "i"
	bevelI.ButtonType = 0
	bevelI.Value = False
	bevelI.left = 403
	bevelI.top = 151
	bevelI.width = 44
	bevelI.height = 33

	bevelI.AddToWindow()

	bevelO = new BevelBtnEx
	bevelO.charcode = "O"
	bevelO.caption = "o"
	bevelO.ButtonType = 0
	bevelO.Value = False
	bevelO.left = 448
	bevelO.top = 151
	bevelO.width = 44
	bevelO.height = 33

	bevelO.AddToWindow()

	bevelP = new BevelBtnEx
	bevelP.charcode = "P"
	bevelP.caption = "p"
	bevelP.ButtonType = 0
	bevelP.Value = False
	bevelP.left = 493
	bevelP.top = 151
	bevelP.width = 44
	bevelP.height = 33

	bevelP.AddToWindow()

	bevel_brkt_open = new BevelBtnEx
	bevel_brkt_open.charcode = "["
	bevel_brkt_open.caption = "["
	bevel_brkt_open.ButtonType = 0
	bevel_brkt_open.Value = False
	bevel_brkt_open.left = 538
	bevel_brkt_open.top = 151
	bevel_brkt_open.width = 44
	bevel_brkt_open.height = 33

	bevel_brkt_open.AddToWindow()

	bevel_brkt_close = new BevelBtnEx
	bevel_brkt_close.charcode = "]"
	bevel_brkt_close.caption = "]"
	bevel_brkt_close.ButtonType = 0
	bevel_brkt_close.Value = False
	bevel_brkt_close.left = 583
	bevel_brkt_close.top = 151
	bevel_brkt_close.width = 44
	bevel_brkt_close.height = 33

	bevel_brkt_close.AddToWindow()

	bevel_backslash = new BevelBtnEx
	bevel_backslash.charcode = "\"
	bevel_backslash.caption = "\"
	bevel_backslash.ButtonType = 0
	bevel_backslash.Value = False
	bevel_backslash.left = 628
	bevel_backslash.top = 151
	bevel_backslash.width = 44
	bevel_backslash.height = 33

	bevel_backslash.AddToWindow()

	bevel_tab = new BevelBtnEx
	bevel_tab.charcode = 9
	bevel_tab.caption = "tab"
	bevel_tab.ButtonType = 0
	bevel_tab.Value = False
	bevel_tab.left = 20
	bevel_tab.top = 151
	bevel_tab.width = 67
	bevel_tab.height = 33

	bevel_tab.AddToWindow()

	bevelA = new BevelBtnEx
	bevelA.charcode = "A"
	bevelA.caption = "a"
	bevelA.ButtonType = 0
	bevelA.Value = False
	bevelA.left = 99
	bevelA.top = 185
	bevelA.width = 44
	bevelA.height = 33

	bevelA.AddToWindow()

	bevelS = new BevelBtnEx
	bevelS.charcode = "S"
	bevelS.caption = "s"
	bevelS.ButtonType = 0
	bevelS.Value = False
	bevelS.left = 144
	bevelS.top = 185
	bevelS.width = 44
	bevelS.height = 33

	bevelS.AddToWindow()

	bevelD = new BevelBtnEx
	bevelD.charcode = "D"
	bevelD.caption = "d"
	bevelD.ButtonType = 0
	bevelD.Value = False
	bevelD.left = 189
	bevelD.top = 185
	bevelD.width = 44
	bevelD.height = 33

	bevelD.AddToWindow()

	bevelF = new BevelBtnEx
	bevelF.charcode = "F"
	bevelF.caption = "f"
	bevelF.ButtonType = 0
	bevelF.Value = False
	bevelF.left = 234
	bevelF.top = 185
	bevelF.width = 44
	bevelF.height = 33

	bevelF.AddToWindow()

	bevelG = new BevelBtnEx
	bevelG.charcode = "G"
	bevelG.caption = "g"
	bevelG.ButtonType = 0
	bevelG.Value = False
	bevelG.left = 279
	bevelG.top = 185
	bevelG.width = 44
	bevelG.height = 33

	bevelG.AddToWindow()

	bevelH = new BevelBtnEx
	bevelH.charcode = "H"
	bevelH.caption = "h"
	bevelH.ButtonType = 0
	bevelH.Value = False
	bevelH.left = 324
	bevelH.top = 185
	bevelH.width = 44
	bevelH.height = 33

	bevelH.AddToWindow()

	bevel_caps_lock = new BevelBtnMod
	bevel_caps_lock.caption = "caps lock"
	bevel_caps_lock.ButtonType = 1
	bevel_caps_lock.Value = False
	bevel_caps_lock.left = 20
	bevel_caps_lock.top = 185
	bevel_caps_lock.width = 78
	bevel_caps_lock.height = 33

	bevel_caps_lock.AddToWindow()
	bevel_caps_lock.AddActionEvent()

	bevelJ = new BevelBtnEx
	bevelJ.charcode = "J"
	bevelJ.caption = "j"
	bevelJ.ButtonType = 0
	bevelJ.Value = False
	bevelJ.left = 369
	bevelJ.top = 185
	bevelJ.width = 44
	bevelJ.height = 33

	bevelJ.AddToWindow()

	bevelK = new BevelBtnEx
	bevelK.charcode = "K"
	bevelK.caption = "k"
	bevelK.ButtonType = 0
	bevelK.Value = False
	bevelK.left = 414
	bevelK.top = 185
	bevelK.width = 44
	bevelK.height = 33

	bevelK.AddToWindow()

	bevelL = new BevelBtnEx
	bevelL.charcode = "L"
	bevelL.caption = "l"
	bevelL.ButtonType = 0
	bevelL.Value = False
	bevelL.left = 459
	bevelL.top = 185
	bevelL.width = 44
	bevelL.height = 33

	bevelL.AddToWindow()

	bevel_colon = new BevelBtnEx
	bevel_colon.AddToWindow()
	bevel_colon.charcode = ";"
	bevel_colon.caption = ";"
	bevel_colon.ButtonType = 0
	bevel_colon.Value = False
	bevel_colon.left = 504
	bevel_colon.top = 185
	bevel_colon.width = 44
	bevel_colon.height = 33


	bevel_quote = new BevelBtnEx
	bevel_quote.charcode = "'"
	bevel_quote.caption = "'"
	bevel_quote.ButtonType = 0
	bevel_quote.Value = False
	bevel_quote.left = 549
	bevel_quote.top = 185
	bevel_quote.width = 44
	bevel_quote.height = 33

	bevel_quote.AddToWindow()

	bevel_return = new BevelBtnEx
	bevel_return.charcode = 13
	bevel_return.caption = "return"
	bevel_return.ButtonType = 0
	bevel_return.Value = False
	bevel_return.left = 594
	bevel_return.top = 185
	bevel_return.width = 78
	bevel_return.height = 33

	bevel_return.AddToWindow()

	bevel_F1 = new BevelBtnEx
	bevel_F1.charcode = 122
	bevel_F1.caption = "F1"
	bevel_F1.ButtonType = 0
	bevel_F1.Value = False
	bevel_F1.left = 67
	bevel_F1.top = 94
	bevel_F1.width = 46
	bevel_F1.height = 22

	bevel_F1.AddToWindow()

	bevel_F2 = new BevelBtnEx
	bevel_F2.charcode = 123
	bevel_F2.caption = "F2"
	bevel_F2.ButtonType = 0
	bevel_F2.Value = False
	bevel_F2.left = 114
	bevel_F2.top = 94
	bevel_F2.width = 46
	bevel_F2.height = 22

	bevel_F2.AddToWindow()

	bevel_F3 = new BevelBtnEx
	bevel_F3.charcode = 99
	bevel_F3.caption = "F3"
	bevel_F3.ButtonType = 0
	bevel_F3.Value = False
	bevel_F3.left = 161
	bevel_F3.top = 94
	bevel_F3.width = 46
	bevel_F3.height = 22

	bevel_F3.AddToWindow()

	bevel_F4 = new BevelBtnEx
	bevel_F4.charcode = 118
	bevel_F4.caption = "F4"
	bevel_F4.ButtonType = 0
	bevel_F4.Value = False
	bevel_F4.left = 208
	bevel_F4.top = 94
	bevel_F4.width = 46
	bevel_F4.height = 22

	bevel_F4.AddToWindow()

	bevel_F5 = new BevelBtnEx
	bevel_F5.charcode = 96
	bevel_F5.caption = "F5"
	bevel_F5.ButtonType = 0
	bevel_F5.Value = False
	bevel_F5.left = 255
	bevel_F5.top = 94
	bevel_F5.width = 46
	bevel_F5.height = 22

	bevel_F5.AddToWindow()

	bevel_F6 = new BevelBtnEx
	bevel_F6.charcode = 97
	bevel_F6.caption = "F6"
	bevel_F6.ButtonType = 0
	bevel_F6.Value = False
	bevel_F6.left = 302
	bevel_F6.top = 94
	bevel_F6.width = 46
	bevel_F6.height = 22

	bevel_F6.AddToWindow()

	bevel_F7 = new BevelBtnEx
	bevel_F7.charcode = 98
	bevel_F7.caption = "F7"
	bevel_F7.ButtonType = 0
	bevel_F7.Value = False
	bevel_F7.left = 349
	bevel_F7.top = 94
	bevel_F7.width = 46
	bevel_F7.height = 22

	bevel_F7.AddToWindow()

	bevel_F8 = new BevelBtnEx
	bevel_F8.charcode = 100
	bevel_F8.caption = "F8"
	bevel_F8.ButtonType = 0
	bevel_F8.Value = False
	bevel_F8.left = 396
	bevel_F8.top = 94
	bevel_F8.width = 46
	bevel_F8.height = 22

	bevel_F8.AddToWindow()

	bevel_F9 = new BevelBtnEx
	bevel_F9.charcode = 101
	bevel_F9.caption = "F9"
	bevel_F9.ButtonType = 0
	bevel_F9.Value = False
	bevel_F9.left = 443
	bevel_F9.top = 94
	bevel_F9.width = 46
	bevel_F9.height = 22

	bevel_F9.AddToWindow()

	bevel_F10 = new BevelBtnEx
	bevel_F10.charcode = 109
	bevel_F10.caption = "F10"
	bevel_F10.ButtonType = 0
	bevel_F10.Value = False
	bevel_F10.left = 490
	bevel_F10.top = 94
	bevel_F10.width = 46
	bevel_F10.height = 22

	bevel_F10.AddToWindow()

	bevel_F11 = new BevelBtnEx
	bevel_F11.charcode = 103
	bevel_F11.caption = "F11"
	bevel_F11.ButtonType = 0
	bevel_F11.Value = False
	bevel_F11.left = 537
	bevel_F11.top = 94
	bevel_F11.width = 46
	bevel_F11.height = 22

	bevel_F11.AddToWindow()

	bevel_F12 = new BevelBtnEx
	bevel_F12.charcode = 111
	bevel_F12.caption = "F12"
	bevel_F12.ButtonType = 0
	bevel_F12.Value = False
	bevel_F12.left = 584
	bevel_F12.top = 94
	bevel_F12.width = 46
	bevel_F12.height = 22

	bevel_F12.AddToWindow()

	bevel_F13 = new BevelBtnEx
	bevel_F13.charcode = 111
	bevel_F13.caption = "F13"
	bevel_F13.ButtonType = 0
	bevel_F13.Value = False
	bevel_F13.left = 632
	bevel_F13.top = 94
	bevel_F13.width = 40
	bevel_F13.height = 22

	bevel_F13.AddToWindow()

	bevelZ = new BevelBtnEx
	bevelZ.charcode = "Z"
	bevelZ.caption = "z"
	bevelZ.ButtonType = 0
	bevelZ.Value = False
	bevelZ.left = 122
	bevelZ.top = 219
	bevelZ.width = 44
	bevelZ.height = 33

	bevelZ.AddToWindow()

	bevelX = new BevelBtnEx
	bevelX.charcode = "X"
	bevelX.caption = "x"
	bevelX.ButtonType = 0
	bevelX.Value = False
	bevelX.left = 167
	bevelX.top = 219
	bevelX.width = 44
	bevelX.height = 33

	bevelX.AddToWindow()

	bevelC = new BevelBtnEx
	bevelC.charcode = "C"
	bevelC.caption = "c"
	bevelC.ButtonType = 0
	bevelC.Value = False
	bevelC.left = 212
	bevelC.top = 219
	bevelC.width = 44
	bevelC.height = 33

	bevelC.AddToWindow()

	bevelV = new BevelBtnEx
	bevelV.charcode = "V"
	bevelV.caption = "v"
	bevelV.ButtonType = 0
	bevelV.Value = False
	bevelV.left = 257
	bevelV.top = 219
	bevelV.width = 44
	bevelV.height = 33

	bevelV.AddToWindow()

	bevelB = new BevelBtnEx
	bevelB.charcode = "B"
	bevelB.caption = "b"
	bevelB.ButtonType = 0
	bevelB.Value = False
	bevelB.left = 302
	bevelB.top = 219
	bevelB.width = 44
	bevelB.height = 33

	bevelB.AddToWindow()

	bevelN = new BevelBtnEx
	bevelN.charcode = "N"
	bevelN.caption = "n"
	bevelN.ButtonType = 0
	bevelN.Value = False
	bevelN.left = 347
	bevelN.top = 219
	bevelN.width = 44
	bevelN.height = 33

	bevelN.AddToWindow()

	bevelM = new BevelBtnEx
	bevelM.charcode = "M"
	bevelM.caption = "m"
	bevelM.ButtonType = 0
	bevelM.Value = False
	bevelM.left = 392
	bevelM.top = 219
	bevelM.width = 44
	bevelM.height = 33

	bevelM.AddToWindow()

	bevel_comma = new BevelBtnEx
	bevel_comma.charcode = ","
	bevel_comma.caption = ","
	bevel_comma.ButtonType = 0
	bevel_comma.Value = False
	bevel_comma.left = 437
	bevel_comma.top = 219
	bevel_comma.width = 44
	bevel_comma.height = 33

	bevel_comma.AddToWindow()

	bevel_dot = new BevelBtnEx
	bevel_dot.charcode = "."
	bevel_dot.caption = "."
	bevel_dot.ButtonType = 0
	bevel_dot.Value = False
	bevel_dot.left = 482
	bevel_dot.top = 219
	bevel_dot.width = 44
	bevel_dot.height = 33

	bevel_dot.AddToWindow()

	bevel_fwdslash = new BevelBtnEx
	bevel_fwdslash.charcode = "/"
	bevel_fwdslash.caption = "/"
	bevel_fwdslash.ButtonType = 0
	bevel_fwdslash.Value = False
	bevel_fwdslash.left = 527
	bevel_fwdslash.top = 219
	bevel_fwdslash.width = 44
	bevel_fwdslash.height = 33

	bevel_fwdslash.AddToWindow()

	bevel_shift_left = new BevelBtnMod
	bevel_shift_left.caption = "shift"
	bevel_shift_left.ButtonType = 1
	bevel_shift_left.Value = False
	bevel_shift_left.left = 20
	bevel_shift_left.top = 219
	bevel_shift_left.width = 101
	bevel_shift_left.height = 33

	bevel_shift_left.AddToWindow()
	bevel_shift_left.AddActionEvent()

	bevel_shift_right = new BevelBtnMod
	bevel_shift_right.caption = "shift"
	bevel_shift_right.ButtonType = 1
	bevel_shift_right.Value = False
	bevel_shift_right.left = 572
	bevel_shift_right.top = 219
	bevel_shift_right.width = 100
	bevel_shift_right.height = 33

	bevel_shift_right.AddToWindow()
	bevel_shift_right.AddActionEvent()

	bevel_option = new BevelBtnMod
	bevel_option.caption = "optn"
	bevel_option.ButtonType = 1
	bevel_option.Value = False
	bevel_option.left = 110
	bevel_option.top = 253
	bevel_option.width = 44
	bevel_option.height = 33

	bevel_option.AddToWindow()
	bevel_option.AddActionEvent()

	bevel_control = new BevelBtnMod
	bevel_control.caption = "ctrl"
	bevel_control.ButtonType = 1
	bevel_control.Value = False
	bevel_control.left = 65
	bevel_control.top = 253
	bevel_control.width = 44
	bevel_control.height = 33

	bevel_control.AddToWindow()
	bevel_control.AddActionEvent()

	bevel_fn = new BevelBtnMod
	bevel_fn.caption = "fn"
	bevel_fn.ButtonType = 1
	bevel_fn.Value = False
	bevel_fn.left = 20
	bevel_fn.top = 253
	bevel_fn.width = 44
	bevel_fn.height = 33

	bevel_fn.AddToWindow()
	bevel_fn.AddActionEvent()

	bevel_cmd_l = new BevelBtnMod
	bevel_cmd_l.caption = "cmnd"
	bevel_cmd_l.ButtonType = 1
	bevel_cmd_l.Value = False
	bevel_cmd_l.left = 155
	bevel_cmd_l.top = 253
	bevel_cmd_l.width = 56
	bevel_cmd_l.height = 33

	bevel_cmd_l.AddToWindow()
	bevel_cmd_l.AddActionEvent()

	bevel_space = new BevelBtnEx
	bevel_space.charcode = " "
	bevel_space.caption = ""
	bevel_space.ButtonType = 0
	bevel_space.Value = False
	bevel_space.left = 212
	bevel_space.top = 253
	bevel_space.width = 224
	bevel_space.height = 33

	bevel_space.AddToWindow()

	bevel_cmd_r = new BevelBtnMod
	bevel_cmd_r.caption = "cmnd"
	bevel_cmd_r.ButtonType = 1
	bevel_cmd_r.Value = False
	bevel_cmd_r.left = 437
	bevel_cmd_r.top = 253
	bevel_cmd_r.width = 56
	bevel_cmd_r.height = 33

	bevel_cmd_r.AddToWindow()
	bevel_cmd_r.AddActionEvent()

	bevel_option2 = new BevelBtnMod
	bevel_option2.caption = "enter"
	bevel_option2.ButtonType = 1
	bevel_option2.Value = False
	bevel_option2.left = 494
	bevel_option2.top = 253
	bevel_option2.width = 43
	bevel_option2.height = 33

	bevel_option2.AddToWindow()
	bevel_option2.AddActionEvent()

	bevel_arrow_up = new BevelBtnEx
	bevel_arrow_up.charcode = 30
	bevel_arrow_up.caption = "up"
	bevel_arrow_up.ButtonType = 0
	bevel_arrow_up.Value = False
	bevel_arrow_up.left = 583
	bevel_arrow_up.top = 253
	bevel_arrow_up.width = 44
	bevel_arrow_up.height = 16

	bevel_arrow_up.AddToWindow()

	bevel_arrow_down = new BevelBtnEx
	bevel_arrow_down.charcode = 31
	bevel_arrow_down.caption = "down"
	bevel_arrow_down.ButtonType = 0
	bevel_arrow_down.Value = False
	bevel_arrow_down.left = 583
	bevel_arrow_down.top = 270
	bevel_arrow_down.width = 44
	bevel_arrow_down.height = 16

	bevel_arrow_down.AddToWindow()

	bevel_arrow_left = new BevelBtnEx
	bevel_arrow_left.charcode = 28
	bevel_arrow_left.caption = "left"
	bevel_arrow_left.ButtonType = 0
	bevel_arrow_left.Value = False
	bevel_arrow_left.left = 538
	bevel_arrow_left.top = 270
	bevel_arrow_left.width = 44
	bevel_arrow_left.height = 16

	bevel_arrow_left.AddToWindow()

	bevel_arrow_right = new BevelBtnEx
	bevel_arrow_right.charcode = 29
	bevel_arrow_right.caption = "right"
	bevel_arrow_right.ButtonType = 0
	bevel_arrow_right.Value = False
	bevel_arrow_right.left = 628
	bevel_arrow_right.top = 270
	bevel_arrow_right.width = 44
	bevel_arrow_right.height = 16

	bevel_arrow_right.AddToWindow()
	win.show()
end sub

Sub CaptionNoModifier()
	bevel0.Caption = "0"
	bevel1.Caption = "1"
	bevel2.Caption = "2"
	bevel3.Caption = "3"
	bevel4.Caption = "4"
	bevel5.Caption = "5"
	bevel6.Caption = "6"
	bevel7.Caption = "7"
	bevel8.Caption = "8"
	bevel9.Caption = "9"

	BevelA.Caption = "a"
	BevelB.Caption = "b"
	BevelC.Caption = "c"
	BevelD.Caption = "d"
	BevelE.Caption = "e"
	BevelF.Caption = "f"
	BevelG.Caption = "g"
	BevelH.Caption = "h"
	BevelI.Caption = "i"
	BevelJ.Caption = "j"
	BevelK.Caption = "k"
	BevelL.Caption = "l"
	BevelM.Caption = "m"
	BevelN.Caption = "n"
	BevelO.Caption = "o"
	BevelP.Caption = "p"
	BevelQ.Caption = "q"
	BevelR.Caption = "r"
	BevelS.Caption = "s"
	BevelT.Caption = "t"
	BevelU.Caption = "u"
	BevelV.Caption = "v"
	BevelW.Caption = "w"
	BevelX.Caption = "x"
	BevelY.Caption = "y"
	BevelZ.Caption = "z"

	bevel_fwdslash.Caption = "/"
	bevel_backslash.Caption = "\"
	bevel_dot.Caption = "."
	bevel_comma.Caption = ","
	bevel_colon.Caption = ";"
	bevel_quote.Caption = "'"
	bevel_brkt_open.Caption = "["
	bevel_brkt_close.Caption = "]"
	bevel_minus.Caption = "-"
	bevel_equal.Caption = "="
	bevel_unquote.Caption = "`"
End Sub

Sub CaptionOptionModifier()
	bevel0.Caption = "º"
	bevel1.Caption = "¡"
	bevel2.Caption = "™"
	bevel3.Caption = "£"
	bevel4.Caption = "¢"
	bevel5.Caption = "∞"
	bevel6.Caption = "§"
	bevel7.Caption = "¶"
	bevel8.Caption = "•"
	bevel9.Caption = "ª"

	BevelA.Caption = "å"
	BevelB.Caption = "∫"
	BevelC.Caption = "ç"
	BevelD.Caption = "∂"
	BevelE.Caption = "´"
	BevelF.Caption = "ƒ"
	BevelG.Caption = "©"
	BevelH.Caption = "˙"
	BevelI.Caption = "ˆ"
	BevelJ.Caption = "∆"
	BevelK.Caption = "˚"
	BevelL.Caption = "¬"
	BevelM.Caption = "µ"
	BevelN.Caption = "˜"
	BevelO.Caption = "ø"
	BevelP.Caption = "π"
	BevelQ.Caption = "œ"
	BevelR.Caption = "®"
	BevelS.Caption = "ß"
	BevelT.Caption = "†"
	BevelU.Caption = "¨"
	BevelV.Caption = "√"
	BevelW.Caption = "∑"
	BevelX.Caption = "≈"
	BevelY.Caption = "¥"
	BevelZ.Caption = "Ω"

	bevel_fwdslash.Caption = "÷"
	bevel_backslash.Caption = "«"
	bevel_dot.Caption = "≥"
	bevel_comma.Caption = "≤"
	bevel_colon.Caption = "…"
	bevel_quote.Caption = "æ"
	bevel_brkt_open.Caption = "“"
	bevel_brkt_close.Caption = "‘"
	bevel_minus.Caption = "–"
	bevel_equal.Caption = "≠"
	bevel_unquote.Caption = "`"
End Sub

Sub CaptionShiftModifier()
	bevel0.Caption = ")"
	bevel1.Caption = "!"
	bevel2.Caption = "@"
	bevel3.Caption = "#"
	bevel4.Caption = "$"
	bevel5.Caption = "%"
	bevel6.Caption = "^"
	bevel7.Caption = "&&"
	bevel8.Caption = "*"
	bevel9.Caption = "("

	BevelA.Caption = "A"
	BevelB.Caption = "B"
	BevelC.Caption = "C"
	BevelD.Caption = "D"
	BevelE.Caption = "E"
	BevelF.Caption = "F"
	BevelG.Caption = "G"
	BevelH.Caption = "H"
	BevelI.Caption = "I"
	BevelJ.Caption = "J"
	BevelK.Caption = "K"
	BevelL.Caption = "L"
	BevelM.Caption = "M"
	BevelN.Caption = "N"
	BevelO.Caption = "O"
	BevelP.Caption = "P"
	BevelQ.Caption = "Q"
	BevelR.Caption = "R"
	BevelS.Caption = "S"
	BevelT.Caption = "T"
	BevelU.Caption = "U"
	BevelV.Caption = "V"
	BevelW.Caption = "W"
	BevelX.Caption = "X"
	BevelY.Caption = "Y"
	BevelZ.Caption = "Z"

	bevel_fwdslash.Caption = "?"
	bevel_backslash.Caption = "|"
	bevel_dot.Caption = ">"
	bevel_comma.Caption = "<"
	bevel_colon.Caption = ":"
	bevel_quote.Caption = """"
	bevel_brkt_open.Caption = "{"
	bevel_brkt_close.Caption = "}"
	bevel_minus.Caption = "_"
	bevel_equal.Caption = "+"
	bevel_unquote.Caption = "~"
End Sub

Sub CaptionShiftOptionModifier()
	bevel0.Caption = "‚"
	bevel1.Caption = " ⁄⁄⁄"
	bevel2.Caption = "€"
	bevel3.Caption = "‹"
	bevel4.Caption = "›"
	bevel5.Caption = "ﬁ"
	bevel6.Caption = "ﬂ"
	bevel7.Caption = "‡"
	bevel8.Caption = "°"
	bevel9.Caption = "·"

	BevelA.Caption = "Å"
	BevelB.Caption = "ı"
	BevelC.Caption = "Ç"
	BevelD.Caption = "Î"
	BevelE.Caption = "´"
	BevelF.Caption = "Ï"
	BevelG.Caption = "˝"
	BevelH.Caption = "Ó"
	BevelI.Caption = "ˆ"
	BevelJ.Caption = "Ô"
	BevelK.Caption = ""
	BevelL.Caption = "Ò"
	BevelM.Caption = "Â"
	BevelN.Caption = "˜"
	BevelO.Caption = "Ø"
	BevelP.Caption = "∏"
	BevelQ.Caption = "Œ"
	BevelR.Caption = "‰"
	BevelS.Caption = "Í"
	BevelT.Caption = "ˇ"
	BevelU.Caption = "¨"
	BevelV.Caption = "◊"
	BevelW.Caption = "„"
	BevelX.Caption = "˛"
	BevelY.Caption = "Á"
	BevelZ.Caption = "¸"

	bevel_fwdslash.Caption = "¿"
	bevel_backslash.Caption = "»"
	bevel_dot.Caption = "˘"
	bevel_comma.Caption = "¯"
	bevel_colon.Caption = "Ú"
	bevel_quote.Caption = "Æ"
	bevel_brkt_open.Caption = "”"
	bevel_brkt_close.Caption = "’"
	bevel_minus.Caption = "—"
	bevel_equal.Caption = "±"
	bevel_unquote.Caption = "`"
End Sub

Sub ChangeCaption(shift as Boolean = false, option as Boolean = false)
  if not shift and not option then CaptionNoModifier
  if shift and not option then CaptionShiftModifier
  if not shift and option then CaptionOptionModifier
  if shift and option then CaptionShiftOptionModifier
End Sub


